package TWiki::Contrib::TWikiShellContrib::Ext::Sdk::Init;

use TWiki::Contrib::TWikiShellContrib::Common;
use TWiki::Contrib::TWikiShellContrib::DirHandling;
use TWiki::Contrib::TWikiShellContrib::Zip;
use File::Copy;
use File::Path;
 
use vars qw (
    $defaultDevelop
    $defaultBase
    );

$defaultDevelop="develop";
$defaultBase="base";
$defaultIncoming="incoming";
$defaultDistro="distros";
$defaultExt="extensions";
$defaultCheckout="checkout";
$defaultPlugins="twikiplugins";

sub run {
    my ($shell,$config)=@_;
    $shell->printTerse("Creating directory structure\n");
    if (! defined $config->{SDK}->{BASE}->{dir}) {
        $shell->printVerbose("   * Creating base installation directory\n");
        mkdir $defaultBase if (! -d $defaultBase);
    }
    
    if (! defined $config->{SDK}->{DEVELOP}->{dir}) {
        $shell->printVerbose("   * Creating development installation directory\n");
        mkdir $defaultDevelop if (! -d $defaultDevelop);
    }

    if (! defined $config->{DISTRO}->{dir}) {
        $shell->printVerbose("   * Creating source distro directory\n");
        mkpath "$defaultIncoming/$defaultDistro" if (! -d "$defaultIncoming/$defaultDistro");
    }

    if (! defined $config->{EXT}->{dir}) {
        $shell->printVerbose("   * Creating source extensions directory\n");
        mkpath "$defaultIncoming/$defaultExt" if (! -d "$defaultIncoming/$defaultExt");
    }

    if (! defined $config->{CHECKOUT}->{DISTRO}->{dir}) {
        $shell->printVerbose("   * Creating defaultCheckout checkout directory\n");
        mkdir "$defaultCheckout" if (! -d "$defaultCheckout");
    }

    if (! defined $config->{CHECKOUT}->{EXT}->{dir}) {
        $shell->printVerbose("   * Creating extensions checkout directory\n");
        mkdir "$defaultPlugins" if (! -d "$defaultPlugins");
    }

#TODO: Set the dirs in config automatically

} 
    

1;
