package TWiki::Contrib::TWikiShellContrib::Ext::Sdk::Uninstall;

use TWiki::Contrib::TWikiShellContrib::Common;
use TWiki::Contrib::TWikiShellContrib::DirHandling;
use TWiki::Contrib::TWikiShellContrib::Zip;
use File::Copy;
use File::Path;

sub run {
    my ($shell,$config,$base,$name) = @_;
    $shell->printTerse("Uninstalling $base/$name");
	_changeApacheConfig($shell,$config,$name,$base);
	my $upperBase=uc $base;
	my $dir=$config->{SDK}{$upperBase}{dir}."/".$name;
	$shell->printVerbose("   * Removing directory $dir \n");
	rmtree($dir);
}

sub smry {
    return "Uninstalls a distro.";
}

sub help {
	    return "  Usage: sdk uninstall <distroname> <targetname>;
      .- Deletes the \${developDir}/<targetname> dir
           WARNING: All changes will be lost.
                    
      .-  The apache http.conf will be modified 
		  to remove this installation.
";
}
	
###################################################

sub _changeApacheConfig {
    my ($shell,$config,$name, $base)=@_;
    print "base $base\n";
    my $upperBase=uc $base;
    my $apacheCfgFile=$config->{SDK}{$upperBase}{Apache};
        
    $shell->printVerbose("   * Modifying $apacheCfgFile\n");
    if (! -e $apacheCfgFile) {
        print "$apacheCfgFile not found\n";
        return;
    }

    $shell->printVerbose("      * Creating  backup of $apacheCfgFile\n");
    my $backupFile=$apacheCfgFile.".sdk".time."~";
    copy($apacheCfgFile,$backupFile);
    $shell->printVerbose("      * Writing new $apacheCfgFile...");
    open INBASE,"<$backupFile";
    my @lines=<INBASE>;
    close INBASE;

    open OUTBASE,">$apacheCfgFile";
    my $removeLines=0;
    my $found=0;
    my $basePath=lc $base."/$name";
    my $firstLine="##################################BEGIN $basePath";
    my $lastLine="#################################################";
    foreach my $line (@lines) {
            if ($line =~ /$firstLine/) {
                $removeLines=1;
            } elsif (($line =~ /$lastLine/) && $removeLines eq 1) {
                $removeLines=0;
                $found=1;
            } elsif (!$removeLines) {
                print OUTBASE $line;
            }
    }
    close OUTBASE;
    
    if ($found) {
        $shell->printVerbose("$basePath removed\n");
    } else {
        $shell->printVerbose("$basePath not found\n");
    }
}

1;
